////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Microsoft Corporation.  All rights reserved.
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _DRIVERS_ANALOG_DECL_H_
#define _DRIVERS_ANALOG_DECL_H_ 1

//--//

//
// Keep in sync with values in cpu.cs
//
enum ANALOG_CHANNEL
{
    ANALOG_CHANNEL_NONE = -1,
    ANALOG_CHANNEL_0    =  0,
    ANALOG_CHANNEL_1    =  1,
    ANALOG_CHANNEL_2    =  2,
    ANALOG_CHANNEL_3    =  3,
    ANALOG_CHANNEL_4    =  4,
    ANALOG_CHANNEL_5    =  5,
    ANALOG_CHANNEL_6    =  6,
    ANALOG_CHANNEL_7    =  7,
    ANALOG_CHANNEL_8    =  8,
    ANALOG_CHANNEL_9    =  9,
    ANALOG_CHANNEL_10   =  10,
    ANALOG_CHANNEL_11   =  11,
    ANALOG_CHANNEL_12   =  12,
    ANALOG_CHANNEL_13   =  13,
    ANALOG_CHANNEL_14   =  14,
    ANALOG_CHANNEL_15   =  15,
    ANALOG_CHANNEL_16   =  16,
    ANALOG_CHANNEL_17   =  17,
    ANALOG_CHANNEL_18   =  18,
    ANALOG_CHANNEL_19   =  19,
    ANALOG_CHANNEL_20   =  20,
    ANALOG_CHANNEL_21   =  21,
    ANALOG_CHANNEL_22   =  22,
    ANALOG_CHANNEL_23   =  23,
    ANALOG_CHANNEL_24   =  24,
    ANALOG_CHANNEL_25   =  25,
    ANALOG_CHANNEL_26   =  26,
    ANALOG_CHANNEL_27   =  27,
    ANALOG_CHANNEL_28   =  28,
    ANALOG_CHANNEL_29   =  29,
    ANALOG_CHANNEL_30   =  30,
    ANALOG_CHANNEL_31   =  31,
};

//--//

// a valua of - 1 for the precision in bits indicates maximum available precision
BOOL  AD_Initialize                     ( ANALOG_CHANNEL channel, INT32 precisionInBits );
INT32 AD_Read                           ( ANALOG_CHANNEL channel );
UINT32 AD_ADChannels                    ( );
GPIO_PIN AD_GetPinForChannel            ( ANALOG_CHANNEL channel );
BOOL AD_GetAvailablePrecisionsForChannel( ANALOG_CHANNEL channel, INT32* precisions, UINT32& size );


//--//

#endif // _DRIVERS_ANALOG_DECL_H_
