////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2010-2011 Kentaro Sekimoto  All rights reserved.
////////////////////////////////////////////////////////////////////////////
#include <tinyhal.h>

HAL_DECLARE_NULL_HEAP();
//HAL_DECLARE_CUSTOM_HEAP(SimpleHeap_Allocate, SimpleHeap_Release,SimpleHeap_ReAllocate);
void PostManagedEvent( UINT8 category, UINT8 subCategory, UINT16 data1, UINT32 data2 )
{
}

//#define USB
#ifdef USB
#define CONSOLE		USB1
#define	EVENT_IN	SYSTEM_EVENT_FLAG_USB_IN
#else
#define CONSOLE		COM1
#define	EVENT_IN	SYSTEM_EVENT_FLAG_COM_IN
#endif

void TestEvent(void)
{
	char key[1];
	int i = 0;
	BOOL state = TRUE;
	GPIO_PIN pin = (GPIO_PIN)0xF3;

	HalSystemConfig.stdio = CONSOLE;
	DebuggerPort_Initialize(HalSystemConfig.stdio);
	hal_printf("========== TestEvent ==========\r\n");
	hal_printf(" NETMF STDIO, Events and GPIO  \r\n");
	hal_printf(" ctrl-c to quit                \r\n");
	hal_printf("===============================\r\n");
	CPU_GPIO_EnableOutputPin(pin, state);
	while (true) {
		CPU_GPIO_SetPinState(pin, state);
		hal_printf("Waiting key %d(sec): ", i++);
		UINT32 Events = Events_WaitForEvents(EVENT_IN, 1000);
		if (Events & EVENT_IN) {
			Events_Clear(EVENT_IN);
			DebuggerPort_Read(HalSystemConfig.stdio, key, 1);
			if (key[0] == 0x03)
				break;
			hal_printf("%c pressed.\r", key[0]);
			i = 0;
		} else {
			hal_printf("           \r");
		}
		state ^= 1;
	}
	hal_printf("\r\n\Program terminated.\r\n");
}

void ApplicationEntryPoint()
{
	TestEvent();
	while (true);
}
