////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2012 Kentaro Sekimoto  All rights reserved.
////////////////////////////////////////////////////////////////////////////

/*
 * FM3_EMAC_lwip_driver.h
 *
 *  Created on: 2012/03/03
 *      Author: Kentaro Sekimoto
 */

#ifndef FM3_EMAC_LWIP_DRIVER_H_
#define FM3_EMAC_LWIP_DRIVER_H_

#include <tinyhal.h>
#include "net_decl_lwip.h"
#include "lwip\dhcp.h"

BOOL FM3_EMAC_LWIP_Init(struct netif *pNetIf);
BOOL FM3_EMAC_LWIP_open(struct netif *pNetIf);
void FM3_EMAC_LWIP_close(struct netif *pNetIf);
void FM3_EMAC_LWIP_interrupt(struct netif *pNetIf);
err_t FM3_EMAC_LWIP_xmit(struct netif *pNetIf, struct pbuf *pPBuf);
void FM3_EMAC_LWIP_recv (struct netif *pNetIf);
void FM3_EMAC_interrupt(void *param);
BOOL FM3_EMAC_LWIP_GetLinkStatus(void);
BOOL FM3_EMAC_LWIP_AutoNegotiate(void);

#define FM3_EMAC_MAX_FRAME_SIZE 1536
#define UPTIME_PERIOD   1000000
#define INT_PERIOD      5000

struct FM3_EMAC_LWIP_DRIVER_CONFIG
{
    GPIO_PIN    PHY_PD_GPIO_Pin;    // phy power down control
};

struct FM3_EMAC_LWIP_Driver
{
    struct dhcp m_currentDhcpSession;
    static int Open(int);
    static BOOL Close(void);
    static BOOL Bind(void );
};

#endif /* FM3_EMAC_LWIP_DRIVER_H_ */
