////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2012 Kentaro Sekimoto  All rights reserved.
////////////////////////////////////////////////////////////////////////////

/*
 * FM3_GPIO.h
 *
 *  Created on: 2012/05/11
 *      Author: Kentaro Sekimoto
 */

#ifndef FM3_GPIO_H_
#define FM3_GPIO_H_

#define FM3_GPIO_INT
#ifdef FM3_GPIO_INT
#define FM3_GPIO_POLLING_INTERVAL    5000    // 5ms
#endif

#define GPIO_PFR(port)  *((volatile UINT32*)(FM3_GPIO_BASE + 0x000UL + ((port) << 2)))
#define GPIO_PCR(port)  *((volatile UINT32*)(FM3_GPIO_BASE + 0x100UL + ((port) << 2)))
#define GPIO_DDR(port)  *((volatile UINT32*)(FM3_GPIO_BASE + 0x200UL + ((port) << 2)))
#define GPIO_PDIR(port) *((volatile UINT32*)(FM3_GPIO_BASE + 0x300UL + ((port) << 2)))
#define GPIO_PDOR(port) *((volatile UINT32*)(FM3_GPIO_BASE + 0x400UL + ((port) << 2)))

#define GPIO_PORT(pin)  (pin >> 4)
#define GPIO_MASK(pin)  (1 << (pin & 0xF))

#ifdef MB9BF618T
#define FM3_GPIO_MAX_PORTS  16
#define FM3_GPIO_MAX_PINS   (FM3_GPIO_MAX_PORTS * 16)
#else
#define FM3_GPIO_MAX_PORTS  9
#define FM3_GPIO_MAX_PINS   (FM3_GPIO_MAX_PORTS * 16)
#endif

struct FM3__GPIO
{
    static const UINT32 c_Pin_None = 0xFFFFFFFF;

    static const UINT8 P00 = 0x00;
    static const UINT8 P01 = 0x01;
    static const UINT8 P02 = 0x02;
    static const UINT8 P03 = 0x03;
    static const UINT8 P04 = 0x04;
    static const UINT8 P05 = 0x05;
    static const UINT8 P06 = 0x06;
    static const UINT8 P07 = 0x07;
    static const UINT8 P08 = 0x08;
    static const UINT8 P09 = 0x09;
    static const UINT8 P0A = 0x0A;
    static const UINT8 P0B = 0x0B;
    static const UINT8 P0C = 0x0C;
    static const UINT8 P0D = 0x0D;
    static const UINT8 P0E = 0x0E;
    static const UINT8 P0F = 0x0F;

    static const UINT8 P10 = 0x10;
    static const UINT8 P11 = 0x11;
    static const UINT8 P12 = 0x12;
    static const UINT8 P13 = 0x13;
    static const UINT8 P14 = 0x14;
    static const UINT8 P15 = 0x15;
    static const UINT8 P16 = 0x16;
    static const UINT8 P17 = 0x17;
    static const UINT8 P18 = 0x18;
    static const UINT8 P19 = 0x19;
    static const UINT8 P1A = 0x1A;
    static const UINT8 P1B = 0x1B;
    static const UINT8 P1C = 0x1C;
    static const UINT8 P1D = 0x1D;
    static const UINT8 P1E = 0x1E;
    static const UINT8 P1F = 0x1F;

    static const UINT8 P20 = 0x20;
    static const UINT8 P21 = 0x21;
    static const UINT8 P22 = 0x22;
    static const UINT8 P23 = 0x23;
    static const UINT8 P24 = 0x24;
    static const UINT8 P25 = 0x25;
    static const UINT8 P26 = 0x26;
    static const UINT8 P27 = 0x27;
    static const UINT8 P28 = 0x28;
    static const UINT8 P29 = 0x29;
    static const UINT8 P2A = 0x2A;
    static const UINT8 P2B = 0x2B;
    static const UINT8 P2C = 0x2C;
    static const UINT8 P2D = 0x2D;
    static const UINT8 P2E = 0x2E;
    static const UINT8 P2F = 0x2F;

    static const UINT8 P30 = 0x30;
    static const UINT8 P31 = 0x31;
    static const UINT8 P32 = 0x32;
    static const UINT8 P33 = 0x33;
    static const UINT8 P34 = 0x34;
    static const UINT8 P35 = 0x35;
    static const UINT8 P36 = 0x36;
    static const UINT8 P37 = 0x37;
    static const UINT8 P38 = 0x38;
    static const UINT8 P39 = 0x39;
    static const UINT8 P3A = 0x3A;
    static const UINT8 P3B = 0x3B;
    static const UINT8 P3C = 0x3C;
    static const UINT8 P3D = 0x3D;
    static const UINT8 P3E = 0x3E;
    static const UINT8 P3F = 0x3F;

    static const UINT8 P40 = 0x40;
    static const UINT8 P41 = 0x41;
    static const UINT8 P42 = 0x42;
    static const UINT8 P43 = 0x43;
    static const UINT8 P44 = 0x44;
    static const UINT8 P45 = 0x45;
    static const UINT8 P46 = 0x46;
    static const UINT8 P47 = 0x47;
    static const UINT8 P48 = 0x48;
    static const UINT8 P49 = 0x49;
    static const UINT8 P4A = 0x4A;
    static const UINT8 P4B = 0x4B;
    static const UINT8 P4C = 0x4C;
    static const UINT8 P4D = 0x4D;
    static const UINT8 P4E = 0x4E;
    static const UINT8 P4F = 0x4F;

    static const UINT8 P50 = 0x50;
    static const UINT8 P51 = 0x51;
    static const UINT8 P52 = 0x52;
    static const UINT8 P53 = 0x53;
    static const UINT8 P54 = 0x54;
    static const UINT8 P55 = 0x55;
    static const UINT8 P56 = 0x56;
    static const UINT8 P57 = 0x57;
    static const UINT8 P58 = 0x58;
    static const UINT8 P59 = 0x59;
    static const UINT8 P5A = 0x5A;
    static const UINT8 P5B = 0x5B;
    static const UINT8 P5C = 0x5C;
    static const UINT8 P5D = 0x5D;
    static const UINT8 P5E = 0x5E;
    static const UINT8 P5F = 0x5F;

    static const UINT8 P60 = 0x60;
    static const UINT8 P61 = 0x61;
    static const UINT8 P62 = 0x62;
    static const UINT8 P63 = 0x63;
    static const UINT8 P64 = 0x64;
    static const UINT8 P65 = 0x65;
    static const UINT8 P66 = 0x66;
    static const UINT8 P67 = 0x67;
    static const UINT8 P68 = 0x68;
    static const UINT8 P69 = 0x69;
    static const UINT8 P6A = 0x6A;
    static const UINT8 P6B = 0x6B;
    static const UINT8 P6C = 0x6C;
    static const UINT8 P6D = 0x6D;
    static const UINT8 P6E = 0x6E;
    static const UINT8 P6F = 0x6F;

    static const UINT8 P70 = 0x70;
    static const UINT8 P71 = 0x71;
    static const UINT8 P72 = 0x72;
    static const UINT8 P73 = 0x73;
    static const UINT8 P74 = 0x74;
    static const UINT8 P75 = 0x75;
    static const UINT8 P76 = 0x76;
    static const UINT8 P77 = 0x77;
    static const UINT8 P78 = 0x78;
    static const UINT8 P79 = 0x79;
    static const UINT8 P7A = 0x7A;
    static const UINT8 P7B = 0x7B;
    static const UINT8 P7C = 0x7C;
    static const UINT8 P7D = 0x7D;
    static const UINT8 P7E = 0x7E;
    static const UINT8 P7F = 0x7F;

    static const UINT8 P80 = 0x80;
    static const UINT8 P81 = 0x81;
    static const UINT8 P82 = 0x82;
    static const UINT8 P83 = 0x83;
    static const UINT8 P84 = 0x84;
    static const UINT8 P85 = 0x85;
    static const UINT8 P86 = 0x86;
    static const UINT8 P87 = 0x87;
    static const UINT8 P88 = 0x88;
    static const UINT8 P89 = 0x89;
    static const UINT8 P8A = 0x8A;
    static const UINT8 P8B = 0x8B;
    static const UINT8 P8C = 0x8C;
    static const UINT8 P8D = 0x8D;
    static const UINT8 P8E = 0x8E;
    static const UINT8 P8F = 0x8F;

    static const UINT8 P90 = 0x90;
    static const UINT8 P91 = 0x91;
    static const UINT8 P92 = 0x92;
    static const UINT8 P93 = 0x93;
    static const UINT8 P94 = 0x94;
    static const UINT8 P95 = 0x95;
    static const UINT8 P96 = 0x96;
    static const UINT8 P97 = 0x97;
    static const UINT8 P98 = 0x98;
    static const UINT8 P99 = 0x99;
    static const UINT8 P9A = 0x9A;
    static const UINT8 P9B = 0x9B;
    static const UINT8 P9C = 0x9C;
    static const UINT8 P9D = 0x9D;
    static const UINT8 P9E = 0x9E;
    static const UINT8 P9F = 0x9F;

    static const UINT8 PA0 = 0xA0;
    static const UINT8 PA1 = 0xA1;
    static const UINT8 PA2 = 0xA2;
    static const UINT8 PA3 = 0xA3;
    static const UINT8 PA4 = 0xA4;
    static const UINT8 PA5 = 0xA5;
    static const UINT8 PA6 = 0xA6;
    static const UINT8 PA7 = 0xA7;
    static const UINT8 PA8 = 0xA8;
    static const UINT8 PA9 = 0xA9;
    static const UINT8 PAA = 0xAA;
    static const UINT8 PAB = 0xAB;
    static const UINT8 PAC = 0xAC;
    static const UINT8 PAD = 0xAD;
    static const UINT8 PAE = 0xAE;
    static const UINT8 PAF = 0xAF;

    static const UINT8 PB0 = 0xB0;
    static const UINT8 PB1 = 0xB1;
    static const UINT8 PB2 = 0xB2;
    static const UINT8 PB3 = 0xB3;
    static const UINT8 PB4 = 0xB4;
    static const UINT8 PB5 = 0xB5;
    static const UINT8 PB6 = 0xB6;
    static const UINT8 PB7 = 0xB7;
    static const UINT8 PB8 = 0xB8;
    static const UINT8 PB9 = 0xB9;
    static const UINT8 PBA = 0xBA;
    static const UINT8 PBB = 0xBB;
    static const UINT8 PBC = 0xBC;
    static const UINT8 PBD = 0xBD;
    static const UINT8 PBE = 0xBE;
    static const UINT8 PBF = 0xBF;

    static const UINT8 PC0 = 0xC0;
    static const UINT8 PC1 = 0xC1;
    static const UINT8 PC2 = 0xC2;
    static const UINT8 PC3 = 0xC3;
    static const UINT8 PC4 = 0xC4;
    static const UINT8 PC5 = 0xC5;
    static const UINT8 PC6 = 0xC6;
    static const UINT8 PC7 = 0xC7;
    static const UINT8 PC8 = 0xC8;
    static const UINT8 PC9 = 0xC9;
    static const UINT8 PCA = 0xCA;
    static const UINT8 PCB = 0xCB;
    static const UINT8 PCC = 0xCC;
    static const UINT8 PCD = 0xCD;
    static const UINT8 PCE = 0xCE;
    static const UINT8 PCF = 0xCF;

    static const UINT8 PD0 = 0xD0;
    static const UINT8 PD1 = 0xD1;
    static const UINT8 PD2 = 0xD2;
    static const UINT8 PD3 = 0xD3;
    static const UINT8 PD4 = 0xD4;
    static const UINT8 PD5 = 0xD5;
    static const UINT8 PD6 = 0xD6;
    static const UINT8 PD7 = 0xD7;
    static const UINT8 PD8 = 0xD8;
    static const UINT8 PD9 = 0xD9;
    static const UINT8 PDA = 0xDA;
    static const UINT8 PDB = 0xDB;
    static const UINT8 PDC = 0xDC;
    static const UINT8 PDD = 0xDD;
    static const UINT8 PDE = 0xDE;
    static const UINT8 PDF = 0xDF;

    static const UINT8 PE0 = 0xE0;
    static const UINT8 PE1 = 0xE1;
    static const UINT8 PE2 = 0xE2;
    static const UINT8 PE3 = 0xE3;
    static const UINT8 PE4 = 0xE4;
    static const UINT8 PE5 = 0xE5;
    static const UINT8 PE6 = 0xE6;
    static const UINT8 PE7 = 0xE7;
    static const UINT8 PE8 = 0xE8;
    static const UINT8 PE9 = 0xE9;
    static const UINT8 PEA = 0xEA;
    static const UINT8 PEB = 0xEB;
    static const UINT8 PEC = 0xEC;
    static const UINT8 PED = 0xED;
    static const UINT8 PEE = 0xEE;
    static const UINT8 PEF = 0xEF;

    static const UINT8 PF0 = 0xF0;
    static const UINT8 PF1 = 0xF1;
    static const UINT8 PF2 = 0xF2;
    static const UINT8 PF3 = 0xF3;
    static const UINT8 PF4 = 0xF4;
    static const UINT8 PF5 = 0xF5;
    static const UINT8 PF6 = 0xF6;
    static const UINT8 PF7 = 0xF7;
    static const UINT8 PF8 = 0xF8;
    static const UINT8 PF9 = 0xF9;
    static const UINT8 PFA = 0xFA;
    static const UINT8 PFB = 0xFB;
    static const UINT8 PFC = 0xFC;
    static const UINT8 PFD = 0xFD;
    static const UINT8 PFE = 0xFE;
    static const UINT8 PFF = 0xFF;
};

struct FM3_GPIO_Driver
{
    struct PIN_ISR_DESCRIPTOR
    {
        static const UINT8 c_Flags_Debounce        = 0x01;
        static const UINT8 c_Flags_RequireLowEdge  = 0x02;
        static const UINT8 c_Flags_RequireHighEdge = 0x04;
        static const UINT8 c_Status_AllowLowEdge   = 0x01;
        static const UINT8 c_Status_AllowHighEdge  = 0x02;

        HAL_COMPLETION m_completion;
        GPIO_INTERRUPT_SERVICE_ROUTINE m_isr;
        void *m_param;
        GPIO_PIN m_pin;
        GPIO_INT_EDGE m_intEdge;
        UINT8 m_flags;
        UINT8 m_status;

        static void Fire(void *arg);
    };

    static const UINT32 c_MaxPins = FM3_GPIO_MAX_PINS;
    static const UINT32 c_MaxPorts = FM3_GPIO_MAX_PORTS;
    static const UINT8 c_GPIO_Attributes[c_MaxPins];
    static const INT32 c_MinDebounceTimeMs = 1;     // 1ms
    static const INT32 c_MaxDebounceTimeMs = 5000;  // 5s
    //static const UINT8 c_GPIO_ResistorMode;
    //static const UINT8 c_GPIO_InterruptMode;

#ifdef FM3_GPIO_INT
    PIN_ISR_DESCRIPTOR m_PinIsr[c_MaxPins];
#endif
    UINT8 m_GPIO_Reserved[c_MaxPins];
    UINT16 m_GPIO_PortLastValues[c_MaxPorts];
    UINT16 m_GPIO_PortReservedMask[c_MaxPorts];
    UINT8 m_GPIO_Driver_Initialized;
    HAL_COMPLETION m_GPIO_Completion;
    UINT32 m_DebounceTicks;
    BOOL m_GPIO_InISR;
    BOOL m_Debounce;
    GPIO_PIN m_pin;

    static BOOL Initialize();
    static BOOL Uninitialize();
    static UINT32 Attributes(GPIO_PIN pin);
    static void DisablePin(GPIO_PIN pin, GPIO_RESISTOR resistorState, UINT32 Direction, GPIO_ALT_MODE AltFunction);
    static void EnableOutputPin(GPIO_PIN pin, BOOL initialState);
    static BOOL EnableInputPin(GPIO_PIN pin, BOOL GlitchFilterEnable, GPIO_INTERRUPT_SERVICE_ROUTINE ISR, void* Param, GPIO_INT_EDGE intEdge, GPIO_RESISTOR resistorState);
    static BOOL GetPinState(GPIO_PIN pin);
    static void SetPinState(GPIO_PIN pin, BOOL pinState);
    static BOOL PinIsBusy(GPIO_PIN pin);
    static BOOL ReservePin(GPIO_PIN pin, BOOL fReserve);
    static UINT32 GetDebounce();
    static BOOL SetDebounce(INT64 debounceTimeMilliseconds);
    static INT32 GetPinCount();
    static void GetPinsMap(UINT8* pins, size_t size);
    static UINT8 GetSupportedResistorModes(GPIO_PIN pin);
    static UINT8 GetSupportedInterruptModes(GPIO_PIN pin);
    static void STUB_ISRVector(GPIO_PIN pin, BOOL PinState, void* Param);
//
#ifdef FM3_GPIO_INT
    static INT32 GetBitPos(UINT16 val);
    static void UpdatePinValue(GPIO_PIN pin);
    static void EnableInputPolling(GPIO_PIN pin);
    static void DisableInputPolling(GPIO_PIN pin);
    static UINT32 ChkPinChange(void);
    static void ISR(void);
#endif
private:
    static void STUB_GPIOISRVector(GPIO_PIN pin, BOOL PinState, void *Param);
};
#endif /* FM3_GPIO_H_ */
